

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Event Channels &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="XenStore wire protocol" href="xenstore_wire_protocol.html"/>
        <link rel="prev" title="Grant Tables" href="grant_tables.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="hypercall_calling_convention.html">Hypercall Calling Convention</a></li>
<li class="toctree-l4"><a class="reference internal" href="supported_hypercalls.html">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_shared_data_structure.html">Start-of-day shared data structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_memory_layout.html">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4"><a class="reference internal" href="elf_notes.html">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>Event Channels</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/event_channels.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="event-channels">
<h1>Event Channels<a class="headerlink" href="#event-channels" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__event__channels"></span><em>group</em> <code class="descname">event_channels</code></dt>
<dd><p>Event channels are the basic primitive provided by Xen for event notifications. An event is the Xen equivalent of a hardware interrupt. They essentially store one bit of information, the event of interest is signalled by transitioning this bit from 0 to 1. </p>
<p>Notifications are received by a guest via an upcall from Xen, indicating when an event arrives (setting the bit). Further notifications are masked until the bit is cleared again (therefore, guests must check the value of the bit after re-enabling event delivery to ensure no missed notifications).</p>
<p>Event notifications can be masked by setting a flag; this is equivalent to disabling interrupts and can be used to ensure atomicity of certain operations in the guest kernel.</p>
<p>Event channels are represented by the evtchn_* fields in struct <a class="reference internal" href="start_of_day_shared_data_structure.html#structshared__info"><span class="std std-ref">shared_info</span></a> and struct vcpu_info. </p>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Defines</p>
<dl class="define">
<dt id="c.EVTCHNOP_bind_interdomain">
<span class="target" id="group__event__channels_1ga3483f93d8b78e60ec7856e2a4ee57304"></span><code class="descname">EVTCHNOP_bind_interdomain</code> 0<a class="headerlink" href="#c.EVTCHNOP_bind_interdomain" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_bind_virq">
<span class="target" id="group__event__channels_1ga795dc96341925d710075030e45f65750"></span><code class="descname">EVTCHNOP_bind_virq</code> 1<a class="headerlink" href="#c.EVTCHNOP_bind_virq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_bind_pirq">
<span class="target" id="group__event__channels_1ga42a0680c05b55a0447e0f6bdb1805cf3"></span><code class="descname">EVTCHNOP_bind_pirq</code> 2<a class="headerlink" href="#c.EVTCHNOP_bind_pirq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_close">
<span class="target" id="group__event__channels_1ga078653022bf42296dfe21769e4b9c1f0"></span><code class="descname">EVTCHNOP_close</code> 3<a class="headerlink" href="#c.EVTCHNOP_close" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_send">
<span class="target" id="group__event__channels_1ga59f6c29f7ef47d003f192d1c8fc9676a"></span><code class="descname">EVTCHNOP_send</code> 4<a class="headerlink" href="#c.EVTCHNOP_send" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_status">
<span class="target" id="group__event__channels_1gaa1ba0fec605174cae49dbe4d7d33ffcd"></span><code class="descname">EVTCHNOP_status</code> 5<a class="headerlink" href="#c.EVTCHNOP_status" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_alloc_unbound">
<span class="target" id="group__event__channels_1ga688357b79034d6c9cadc9fde62716e67"></span><code class="descname">EVTCHNOP_alloc_unbound</code> 6<a class="headerlink" href="#c.EVTCHNOP_alloc_unbound" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_bind_ipi">
<span class="target" id="group__event__channels_1ga547b2ee658a9ebaeb38e732da7241575"></span><code class="descname">EVTCHNOP_bind_ipi</code> 7<a class="headerlink" href="#c.EVTCHNOP_bind_ipi" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_bind_vcpu">
<span class="target" id="group__event__channels_1ga8677a6dccd99efb40a218e0affeee20f"></span><code class="descname">EVTCHNOP_bind_vcpu</code> 8<a class="headerlink" href="#c.EVTCHNOP_bind_vcpu" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_unmask">
<span class="target" id="group__event__channels_1ga56d70d3fcc8ed685a3282aea1715df56"></span><code class="descname">EVTCHNOP_unmask</code> 9<a class="headerlink" href="#c.EVTCHNOP_unmask" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_reset">
<span class="target" id="group__event__channels_1gaa055408833212f615860a0d839f9e749"></span><code class="descname">EVTCHNOP_reset</code> 10<a class="headerlink" href="#c.EVTCHNOP_reset" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_init_control">
<span class="target" id="group__event__channels_1gac27259ea173feb1bdf032f2e5f7d9b24"></span><code class="descname">EVTCHNOP_init_control</code> 11<a class="headerlink" href="#c.EVTCHNOP_init_control" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_expand_array">
<span class="target" id="group__event__channels_1gae3638932df91767358c8b1258ee8a14a"></span><code class="descname">EVTCHNOP_expand_array</code> 12<a class="headerlink" href="#c.EVTCHNOP_expand_array" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_set_priority">
<span class="target" id="group__event__channels_1ga2aff242f251d2ac6a3f1d65e10e5d4e0"></span><code class="descname">EVTCHNOP_set_priority</code> 13<a class="headerlink" href="#c.EVTCHNOP_set_priority" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHNOP_reset_cont">
<span class="target" id="group__event__channels_1ga32641f7fba457a08f86016bc2e69dcd7"></span><code class="descname">EVTCHNOP_reset_cont</code> 14<a class="headerlink" href="#c.EVTCHNOP_reset_cont" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_2L_NR_CHANNELS">
<span class="target" id="group__event__channels_1gacdcf92372fa5ac60b219cd5e34d82fdf"></span><code class="descname">EVTCHN_2L_NR_CHANNELS</code> (sizeof(xen_ulong_t) * sizeof(xen_ulong_t) * 64)<a class="headerlink" href="#c.EVTCHN_2L_NR_CHANNELS" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_PRIORITY_MAX">
<span class="target" id="group__event__channels_1ga4a1542908ad20b4fd2c54545c9b7f111"></span><code class="descname">EVTCHN_FIFO_PRIORITY_MAX</code> 0<a class="headerlink" href="#c.EVTCHN_FIFO_PRIORITY_MAX" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_PRIORITY_DEFAULT">
<span class="target" id="group__event__channels_1gaacab8ac748ae6e5adf5fc817efc6509b"></span><code class="descname">EVTCHN_FIFO_PRIORITY_DEFAULT</code> 7<a class="headerlink" href="#c.EVTCHN_FIFO_PRIORITY_DEFAULT" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_PRIORITY_MIN">
<span class="target" id="group__event__channels_1gab375f304a3079b6ee87cb82d4b622437"></span><code class="descname">EVTCHN_FIFO_PRIORITY_MIN</code> 15<a class="headerlink" href="#c.EVTCHN_FIFO_PRIORITY_MIN" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_MAX_QUEUES">
<span class="target" id="group__event__channels_1ga3e9581b2d99f9c7edb64e59fbd6a61bc"></span><code class="descname">EVTCHN_FIFO_MAX_QUEUES</code> (EVTCHN_FIFO_PRIORITY_MIN + 1)<a class="headerlink" href="#c.EVTCHN_FIFO_MAX_QUEUES" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_PENDING">
<span class="target" id="group__event__channels_1ga49a2391657a1b74625c9183089b46a3f"></span><code class="descname">EVTCHN_FIFO_PENDING</code> 31<a class="headerlink" href="#c.EVTCHN_FIFO_PENDING" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_MASKED">
<span class="target" id="group__event__channels_1gaaef34eff5a705bb32ef38e09bdbd2ee4"></span><code class="descname">EVTCHN_FIFO_MASKED</code> 30<a class="headerlink" href="#c.EVTCHN_FIFO_MASKED" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_LINKED">
<span class="target" id="group__event__channels_1ga999101c10a49d7d4560c4693a8b3256c"></span><code class="descname">EVTCHN_FIFO_LINKED</code> 29<a class="headerlink" href="#c.EVTCHN_FIFO_LINKED" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_BUSY">
<span class="target" id="group__event__channels_1ga8b897354c4bef4de1ea79af1a663cc19"></span><code class="descname">EVTCHN_FIFO_BUSY</code> 28<a class="headerlink" href="#c.EVTCHN_FIFO_BUSY" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_LINK_BITS">
<span class="target" id="group__event__channels_1gab9542eca9ead94c871903dcfd0fc1460"></span><code class="descname">EVTCHN_FIFO_LINK_BITS</code> 17<a class="headerlink" href="#c.EVTCHN_FIFO_LINK_BITS" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_LINK_MASK">
<span class="target" id="group__event__channels_1ga19d9ef88512f800a2bfdf423f8598e4b"></span><code class="descname">EVTCHN_FIFO_LINK_MASK</code> ((1 &lt;&lt; EVTCHN_FIFO_LINK_BITS) - 1)<a class="headerlink" href="#c.EVTCHN_FIFO_LINK_MASK" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="define">
<dt id="c.EVTCHN_FIFO_NR_CHANNELS">
<span class="target" id="group__event__channels_1gad6b57ec85a5fb81ba7037b4f25ea7c02"></span><code class="descname">EVTCHN_FIFO_NR_CHANNELS</code> (1 &lt;&lt; EVTCHN_FIFO_LINK_BITS)<a class="headerlink" href="#c.EVTCHN_FIFO_NR_CHANNELS" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Typedefs</p>
<dl class="typedef">
<dt id="c.evtchn_port_t">
<span class="target" id="group__event__channels_1gaaad5124a66f37437561260d1170ab33f"></span><em class="property">typedef </em>uint32_t <code class="descname">evtchn_port_t</code><a class="headerlink" href="#c.evtchn_port_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_alloc_unbound_t">
<span class="target" id="group__event__channels_1ga2f53913488e4b1105b164c429ef21bac"></span><em class="property">typedef </em>struct evtchn_alloc_unbound <code class="descname">evtchn_alloc_unbound_t</code><a class="headerlink" href="#c.evtchn_alloc_unbound_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_bind_interdomain_t">
<span class="target" id="group__event__channels_1gac758af7badcae4377a5df682ff4ea248"></span><em class="property">typedef </em>struct evtchn_bind_interdomain <code class="descname">evtchn_bind_interdomain_t</code><a class="headerlink" href="#c.evtchn_bind_interdomain_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_bind_virq_t">
<span class="target" id="group__event__channels_1gaba20782bb974a2a78fe02126700dc49b"></span><em class="property">typedef </em>struct evtchn_bind_virq <code class="descname">evtchn_bind_virq_t</code><a class="headerlink" href="#c.evtchn_bind_virq_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_bind_pirq_t">
<span class="target" id="group__event__channels_1ga009a879a361daf461d2a592768016580"></span><em class="property">typedef </em>struct evtchn_bind_pirq <code class="descname">evtchn_bind_pirq_t</code><a class="headerlink" href="#c.evtchn_bind_pirq_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_bind_ipi_t">
<span class="target" id="group__event__channels_1gad6eae5adb079582ffd1cd6b2b2c64400"></span><em class="property">typedef </em>struct evtchn_bind_ipi <code class="descname">evtchn_bind_ipi_t</code><a class="headerlink" href="#c.evtchn_bind_ipi_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_close_t">
<span class="target" id="group__event__channels_1gad19c601c41adcd9e235695073e11fa31"></span><em class="property">typedef </em>struct evtchn_close <code class="descname">evtchn_close_t</code><a class="headerlink" href="#c.evtchn_close_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_send_t">
<span class="target" id="group__event__channels_1ga7c4630750087f7f7586488f49cd55d4e"></span><em class="property">typedef </em>struct evtchn_send <code class="descname">evtchn_send_t</code><a class="headerlink" href="#c.evtchn_send_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_status_t">
<span class="target" id="group__event__channels_1ga8ed9ed5019e8da76a67eaddc44c3f6a9"></span><em class="property">typedef </em>struct evtchn_status <code class="descname">evtchn_status_t</code><a class="headerlink" href="#c.evtchn_status_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_bind_vcpu_t">
<span class="target" id="group__event__channels_1ga0b1b9ccc4b4681dc73ae339459b7f5ac"></span><em class="property">typedef </em>struct evtchn_bind_vcpu <code class="descname">evtchn_bind_vcpu_t</code><a class="headerlink" href="#c.evtchn_bind_vcpu_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_unmask_t">
<span class="target" id="group__event__channels_1gadf108a8c569745708da92551dcad289c"></span><em class="property">typedef </em>struct evtchn_unmask <code class="descname">evtchn_unmask_t</code><a class="headerlink" href="#c.evtchn_unmask_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_reset_t">
<span class="target" id="group__event__channels_1ga6338f2371d708c16d85dcabfe88ebffb"></span><em class="property">typedef </em>struct evtchn_reset <code class="descname">evtchn_reset_t</code><a class="headerlink" href="#c.evtchn_reset_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_init_control_t">
<span class="target" id="group__event__channels_1gaab93bcdbb2bbe5950504d4c6afcc48a4"></span><em class="property">typedef </em>struct evtchn_init_control <code class="descname">evtchn_init_control_t</code><a class="headerlink" href="#c.evtchn_init_control_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_expand_array_t">
<span class="target" id="group__event__channels_1gaa0affa83e71ae3587dc66284bf8590c4"></span><em class="property">typedef </em>struct evtchn_expand_array <code class="descname">evtchn_expand_array_t</code><a class="headerlink" href="#c.evtchn_expand_array_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_set_priority_t">
<span class="target" id="group__event__channels_1ga497a6a153a0f6152a9c33686d4601a3b"></span><em class="property">typedef </em>struct evtchn_set_priority <code class="descname">evtchn_set_priority_t</code><a class="headerlink" href="#c.evtchn_set_priority_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_op_t">
<span class="target" id="group__event__channels_1gabaed7bb50dd7fcb741eb5700741985cb"></span><em class="property">typedef </em>struct evtchn_op <code class="descname">evtchn_op_t</code><a class="headerlink" href="#c.evtchn_op_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.event_word_t">
<span class="target" id="group__event__channels_1gacd0b22ec8168a048740469cae89d6104"></span><em class="property">typedef </em>uint32_t <code class="descname">event_word_t</code><a class="headerlink" href="#c.event_word_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="typedef">
<dt id="c.evtchn_fifo_control_block_t">
<span class="target" id="group__event__channels_1gaedb1a3eaf5362bd5288d38412ee96466"></span><em class="property">typedef </em>struct evtchn_fifo_control_block <code class="descname">evtchn_fifo_control_block_t</code><a class="headerlink" href="#c.evtchn_fifo_control_block_t" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<dl class="type">
<dt id="_CPPv228__guest_handle_evtchn_port_t">
<span id="__guest_handle_evtchn_port_t"></span><span class="target" id="union____guest__handle__evtchn__port__t"></span><em class="property">union </em><code class="descname">__guest_handle_evtchn_port_t</code><a class="headerlink" href="#_CPPv228__guest_handle_evtchn_port_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_evtchn_port_t::p">
<span class="target" id="union____guest__handle__evtchn__port__t_1ac3bd4f51a4b6393f9b5d23522fbe84ca"></span><a class="reference internal" href="#c.evtchn_port_t" title="evtchn_port_t">evtchn_port_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_evtchn_port_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_evtchn_port_t::q">
<span class="target" id="union____guest__handle__evtchn__port__t_1a68317853329ef39871c5aee7ad6e2c20"></span>unsigned long <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_evtchn_port_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv231__guest_handle_64_evtchn_port_t">
<span id="__guest_handle_64_evtchn_port_t"></span><span class="target" id="union____guest__handle__64__evtchn__port__t"></span><em class="property">union </em><code class="descname">__guest_handle_64_evtchn_port_t</code><a class="headerlink" href="#_CPPv231__guest_handle_64_evtchn_port_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_64_evtchn_port_t::p">
<span class="target" id="union____guest__handle__64__evtchn__port__t_1a9d0811dfe9788e2d88548866e5980fb2"></span><a class="reference internal" href="#c.evtchn_port_t" title="evtchn_port_t">evtchn_port_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_64_evtchn_port_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_64_evtchn_port_t::q">
<span class="target" id="union____guest__handle__64__evtchn__port__t_1a2e784e4a2d62745e1fb1cee33150db9e"></span>uint64_t <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_64_evtchn_port_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv234__guest_handle_const_evtchn_port_t">
<span id="__guest_handle_const_evtchn_port_t"></span><span class="target" id="union____guest__handle__const__evtchn__port__t"></span><em class="property">union </em><code class="descname">__guest_handle_const_evtchn_port_t</code><a class="headerlink" href="#_CPPv234__guest_handle_const_evtchn_port_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_const_evtchn_port_t::p">
<span class="target" id="union____guest__handle__const__evtchn__port__t_1aebedf88be35ede2bac6fee5a7997ef56"></span>const <a class="reference internal" href="#c.evtchn_port_t" title="evtchn_port_t">evtchn_port_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_const_evtchn_port_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_const_evtchn_port_t::q">
<span class="target" id="union____guest__handle__const__evtchn__port__t_1a0b41ef8d059b22c3337524e3a8c0fabe"></span>unsigned long <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_const_evtchn_port_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv237__guest_handle_64_const_evtchn_port_t">
<span id="__guest_handle_64_const_evtchn_port_t"></span><span class="target" id="union____guest__handle__64__const__evtchn__port__t"></span><em class="property">union </em><code class="descname">__guest_handle_64_const_evtchn_port_t</code><a class="headerlink" href="#_CPPv237__guest_handle_64_const_evtchn_port_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_64_const_evtchn_port_t::p">
<span class="target" id="union____guest__handle__64__const__evtchn__port__t_1aefa452a2999bcc0729553c8608b47647"></span>const <a class="reference internal" href="#c.evtchn_port_t" title="evtchn_port_t">evtchn_port_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_64_const_evtchn_port_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_64_const_evtchn_port_t::q">
<span class="target" id="union____guest__handle__64__const__evtchn__port__t_1a55cf5e845c2950b70b44c8a8e75386e7"></span>uint64_t <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_64_const_evtchn_port_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="class">
<dt id="_CPPv213evtchn_status">
<span id="evtchn_status"></span><span class="target" id="structevtchn__status"></span><em class="property">struct </em><code class="descname">evtchn_status</code><a class="headerlink" href="#_CPPv213evtchn_status" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><dl class="union">
<dt id="c.evtchn_status::anonymous_union_0">
<span class="target" id="unionevtchn__status_1_1anonymous__union__0"></span><em class="property">union </em><code class="descname">anonymous_union_0</code><a class="headerlink" href="#c.evtchn_status::anonymous_union_0" title="Permalink to this definition">¶</a></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.evtchn_status::anonymous_union_0::unbound">
<span class="target" id="unionevtchn__status_1_1anonymous__union__0_1a644743e918b87af11d1192b5c80f2618"></span>struct evtchn_status::anonymous_union_0::anonymous_struct_0  <code class="descname">anonymous_union_0::unbound</code><a class="headerlink" href="#c.evtchn_status::anonymous_union_0::unbound" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_status::anonymous_union_0::interdomain">
<span class="target" id="unionevtchn__status_1_1anonymous__union__0_1ac2a688264e5dd4bc545be2f983c9464b"></span>struct evtchn_status::anonymous_union_0::anonymous_struct_1  <code class="descname">anonymous_union_0::interdomain</code><a class="headerlink" href="#c.evtchn_status::anonymous_union_0::interdomain" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_status::anonymous_union_0::pirq">
<span class="target" id="unionevtchn__status_1_1anonymous__union__0_1a5c1b4723d99d178375ff5e8ae0b7b8a1"></span>uint32_t <code class="descname">anonymous_union_0::pirq</code><a class="headerlink" href="#c.evtchn_status::anonymous_union_0::pirq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_status::anonymous_union_0::virq">
<span class="target" id="unionevtchn__status_1_1anonymous__union__0_1a04e1b6407c81012ce36daaaa22f40cba"></span>uint32_t <code class="descname">anonymous_union_0::virq</code><a class="headerlink" href="#c.evtchn_status::anonymous_union_0::virq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

</dd></dl>

<dl class="class">
<dt id="_CPPv29evtchn_op">
<span id="evtchn_op"></span><span class="target" id="structevtchn__op"></span><em class="property">struct </em><code class="descname">evtchn_op</code><a class="headerlink" href="#_CPPv29evtchn_op" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><dl class="union">
<dt id="c.evtchn_op::anonymous_union_1">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1"></span><em class="property">union </em><code class="descname">anonymous_union_1</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1" title="Permalink to this definition">¶</a></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::alloc_unbound">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1abfb9b4281a73ba7feca695d967a69b7d"></span><a class="reference internal" href="#c.evtchn_alloc_unbound_t" title="evtchn_alloc_unbound_t">evtchn_alloc_unbound_t</a> <code class="descname">anonymous_union_1::alloc_unbound</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::alloc_unbound" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::bind_interdomain">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a31fdac078390395d0b05510e98651eee"></span><a class="reference internal" href="#c.evtchn_bind_interdomain_t" title="evtchn_bind_interdomain_t">evtchn_bind_interdomain_t</a> <code class="descname">anonymous_union_1::bind_interdomain</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::bind_interdomain" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::bind_virq">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a021d9b25c485ccbf06884f8908a71b40"></span><a class="reference internal" href="#c.evtchn_bind_virq_t" title="evtchn_bind_virq_t">evtchn_bind_virq_t</a> <code class="descname">anonymous_union_1::bind_virq</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::bind_virq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::bind_pirq">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1aa8bf5cfc39bd1e6e0f82a1bc44affbff"></span><a class="reference internal" href="#c.evtchn_bind_pirq_t" title="evtchn_bind_pirq_t">evtchn_bind_pirq_t</a> <code class="descname">anonymous_union_1::bind_pirq</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::bind_pirq" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::bind_ipi">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a0f4a453b4036f49ff7bf4acf1a213229"></span><a class="reference internal" href="#c.evtchn_bind_ipi_t" title="evtchn_bind_ipi_t">evtchn_bind_ipi_t</a> <code class="descname">anonymous_union_1::bind_ipi</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::bind_ipi" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::close">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a5b9dba8305d824503c639e0b7b7c198f"></span><a class="reference internal" href="#c.evtchn_close_t" title="evtchn_close_t">evtchn_close_t</a> <code class="descname">anonymous_union_1::close</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::close" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::send">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a671ebe1ced240cdffe63da6fff4ea295"></span><a class="reference internal" href="#c.evtchn_send_t" title="evtchn_send_t">evtchn_send_t</a> <code class="descname">anonymous_union_1::send</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::send" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::status">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1ab0a703d3ab6078df48a053d1d51ef3fb"></span><a class="reference internal" href="#c.evtchn_status_t" title="evtchn_status_t">evtchn_status_t</a> <code class="descname">anonymous_union_1::status</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::status" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::bind_vcpu">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1ac49d2e9a893d3298efe0e5bc6f28cc1f"></span><a class="reference internal" href="#c.evtchn_bind_vcpu_t" title="evtchn_bind_vcpu_t">evtchn_bind_vcpu_t</a> <code class="descname">anonymous_union_1::bind_vcpu</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::bind_vcpu" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.evtchn_op::anonymous_union_1::unmask">
<span class="target" id="unionevtchn__op_1_1anonymous__union__1_1a13e4c19678400efb907bbe1032c5cbfb"></span><a class="reference internal" href="#c.evtchn_unmask_t" title="evtchn_unmask_t">evtchn_unmask_t</a> <code class="descname">anonymous_union_1::unmask</code><a class="headerlink" href="#c.evtchn_op::anonymous_union_1::unmask" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

</dd></dl>

<dl class="type">
<dt id="_CPPv226__guest_handle_evtchn_op_t">
<span id="__guest_handle_evtchn_op_t"></span><span class="target" id="union____guest__handle__evtchn__op__t"></span><em class="property">union </em><code class="descname">__guest_handle_evtchn_op_t</code><a class="headerlink" href="#_CPPv226__guest_handle_evtchn_op_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_evtchn_op_t::p">
<span class="target" id="union____guest__handle__evtchn__op__t_1a7e5089ca5f2a53d39fc251de556786cb"></span><a class="reference internal" href="#c.evtchn_op_t" title="evtchn_op_t">evtchn_op_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_evtchn_op_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_evtchn_op_t::q">
<span class="target" id="union____guest__handle__evtchn__op__t_1af814ebe163b1f40dd351de0c31483925"></span>unsigned long <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_evtchn_op_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv229__guest_handle_64_evtchn_op_t">
<span id="__guest_handle_64_evtchn_op_t"></span><span class="target" id="union____guest__handle__64__evtchn__op__t"></span><em class="property">union </em><code class="descname">__guest_handle_64_evtchn_op_t</code><a class="headerlink" href="#_CPPv229__guest_handle_64_evtchn_op_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_64_evtchn_op_t::p">
<span class="target" id="union____guest__handle__64__evtchn__op__t_1a7cd2095d92791fc168808a4a83a5e034"></span><a class="reference internal" href="#c.evtchn_op_t" title="evtchn_op_t">evtchn_op_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_64_evtchn_op_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_64_evtchn_op_t::q">
<span class="target" id="union____guest__handle__64__evtchn__op__t_1a662f4efa3beceb19d17120ed82c7326d"></span>uint64_t <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_64_evtchn_op_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv232__guest_handle_const_evtchn_op_t">
<span id="__guest_handle_const_evtchn_op_t"></span><span class="target" id="union____guest__handle__const__evtchn__op__t"></span><em class="property">union </em><code class="descname">__guest_handle_const_evtchn_op_t</code><a class="headerlink" href="#_CPPv232__guest_handle_const_evtchn_op_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_const_evtchn_op_t::p">
<span class="target" id="union____guest__handle__const__evtchn__op__t_1a00866c6fe84c572e00a958224f54dc5e"></span>const <a class="reference internal" href="#c.evtchn_op_t" title="evtchn_op_t">evtchn_op_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_const_evtchn_op_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_const_evtchn_op_t::q">
<span class="target" id="union____guest__handle__const__evtchn__op__t_1a0b5858553d6de2b6fd044a096f2949fa"></span>unsigned long <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_const_evtchn_op_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="type">
<dt id="_CPPv235__guest_handle_64_const_evtchn_op_t">
<span id="__guest_handle_64_const_evtchn_op_t"></span><span class="target" id="union____guest__handle__64__const__evtchn__op__t"></span><em class="property">union </em><code class="descname">__guest_handle_64_const_evtchn_op_t</code><a class="headerlink" href="#_CPPv235__guest_handle_64_const_evtchn_op_t" title="Permalink to this definition">¶</a><br /></dt>
<dd><em>#include &lt;event_channel.h&gt;</em><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt id="c.__guest_handle_64_const_evtchn_op_t::p">
<span class="target" id="union____guest__handle__64__const__evtchn__op__t_1a673d6948b9466ca401628e10a2141a72"></span>const <a class="reference internal" href="#c.evtchn_op_t" title="evtchn_op_t">evtchn_op_t</a>* <code class="descname">p</code><a class="headerlink" href="#c.__guest_handle_64_const_evtchn_op_t::p" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.__guest_handle_64_const_evtchn_op_t::q">
<span class="target" id="union____guest__handle__64__const__evtchn__op__t_1af9c69961757124fc69553d674cb201bb"></span>uint64_t <code class="descname">q</code><a class="headerlink" href="#c.__guest_handle_64_const_evtchn_op_t::q" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="xenstore_wire_protocol.html" class="btn btn-neutral float-right" title="XenStore wire protocol" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="grant_tables.html" class="btn btn-neutral" title="Grant Tables" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>